#define _XOPEN_SOURCE 1
#define _XOPEN_SOURCE_EXTENDED 1
#include <unistd.h>
#include <limits.h>

static char const prog[]="setblock";

int main(int argc, char** argv) {
  for (argc=(argc!=0); argv[argc]!=null; ++argc) {
    char const* arg=argv[argc];
    int set=(arg[0]=='+');
    unsigned long fd;
    unsigned int len;

    if (arg[0]!='+' && arg[0]!='-')
      strerr_die4x(111, prog, usage, prog, "{+|-}fd [...]");

    ++arg;
    len=scan_ulong(arg, &fd);

    if (len==0 || arg[len]!='\0')
      strerr_die6x(111, prog, fatal, arg_fd, err_malformed, err_, arg);
    if (fd>INT_MAX)
      strerr_die5x(100, prog, fatal, arg_fd, err_oflow, t_int);

    switch (setblock(fd, set)) {
      case setblock_success: continue;
      case setblock_getfl:
        strerr_die6sys(100, prog, fatal, err_unable, "get flags for fd ", arg,
                       err_);
      case setblock_setfl:
        strerr_die6sys(100, prog, fatal, err_unable, "set flags for fd ", arg,
                       err_);
      default:
        strerr_die4sys(111, prog, fatal, err_unknown, err_);
    }
  }

  _exit(0);
}
